VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsBpcaFocus"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
' == Caution for use! ==
'
' When you copy a class module in workbook,
' please perform it by Export & Import from Bpca_Focus_V150E.xls by all means.
' (The export file of the class module prepares in the distribution file.)
' If you perform it by Copy & Paste between code windows of VBE,
' Default-property (Item) do not work.

'_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
'_/
'_/ [ clsBpcaFocus ]  Ver1.5
'_/
'_/   --- Breakthrough in the Pseudo-Control-Array --- (Excel2000 or later)
'_/   The class module which provides the Focus Moving detection by Control-Array.
'_/
'_/     << Target Control >>
'_/        ListBox, CommandButton, TextBox, CheckBox
'_/        OptionButton, ToggleButton, ComboBox
'_/        SpinButton, ScrollBar, Frame, MultiPage, TabStrip
'_/
'_/     AddinBox(K.Tsunoda) CopyRight(C) 2004 Allrights Reserved.
'_/       [http://addinbox.sakura.ne.jp/Breakthrough_P-Ctrl_Arrays_Eng3.htm ]
'_/       [http://addinbox.sakura.ne.jp/index.htm]
'_/       [Old Site  http://www.h3.dion.ne.jp/~sakatsu/index.htm]
'_/
'_/     2004/6/1  Ver1.0  1st version(Jpn.)
'_/     2004/6/23 Ver1.1
'_/     2005/3/10 Ver1.2
'_/     2011/4/15 Ver1.3
'_/     2011/9/20 Ver1.4
'_/     2014/7/22 Ver1.5
'_/
'_/     2016/10/4 Ver1.5 English version (1st version)
'_/
'_/  [ clsBpcaFocusCh ] module is necessary together.
'_/  It works in x64.
'_/
'_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/

'-----[ Event definition ]-----------------------------------------------
Public Event GotFocus(ByVal Index As Integer)
Public Event LostFocus(ByVal Index As Integer)
'------------------------------------------------------------------
Private clsBpcaCtrlCh() As clsBpcaFocusCh   'Child class
Private colBpcaCtrlGrp As Collection        'Storage collection of Controls
Private MyForm As MsForms.UserForm

Private intPreIndex As Integer              'Index of ActiveControl just before
Private blnRgst As Boolean                  'Registration flag

'==============================================================
Private Sub Class_Initialize()
    blnRgst = False
    Set colBpcaCtrlGrp = New Collection
    Set MyForm = Nothing
    intPreIndex = 0
End Sub

Private Sub Class_Terminate()
    If (blnRgst = True) Or (Not (colBpcaCtrlGrp Is Nothing)) Then
        Me.Clear
    End If
End Sub

'======== Property / Method definition =============================

'---( Add method )------------------------------------------------
'Add control to become array to collection.
Public Sub Add(ByVal NewCtrl As Object)
    If (blnRgst = False) Then
        Select Case TypeName(NewCtrl)
          'Input control
          Case "ListBox", "CommandButton", "TextBox", _
               "CheckBox", "OptionButton", "ToggleButton", _
               "ComboBox", "SpinButton", "ScrollBar"
            colBpcaCtrlGrp.Add NewCtrl
            
          'Container control
          Case "Frame", "MultiPage", "TabStrip"
            colBpcaCtrlGrp.Add NewCtrl
            
          'Non-input control (Label etc.) or Other than MsForms (RefEdit etc.)
          Case Else
            'do not add
        End Select
    Else
        'Because Rgst method is executed, I do not add it.
    End If
End Sub

'---( Rgst method )------------------------------------------------
'I set the control that enrolled in collection in the array of the clsBpcaFocusCh class.
'I receive the classification of the event to produce by an argument.
Public Sub Rgst(ByVal NewForm As MsForms.UserForm)
Dim strTypeName As String
Dim i As Integer
    If (blnRgst = True) Then
        'Because Rgst method is executed, I do not handle it.
    ElseIf (colBpcaCtrlGrp.Count = 0) Or _
           (NewForm Is Nothing) Then
        blnRgst = False
    Else
        ReDim clsBpcaCtrlCh(1 To colBpcaCtrlGrp.Count)
        For i = 1 To colBpcaCtrlGrp.Count
            Set clsBpcaCtrlCh(i) = New clsBpcaFocusCh
            With clsBpcaCtrlCh(i)
                .Item = colBpcaCtrlGrp(i)
                .Index = i
                .Parent = Me
            End With
        Next i
        Set MyForm = NewForm
        blnRgst = True
    End If
End Sub

'---( Clear method )-----------------------------
Public Sub Clear()
Dim i As Integer
    If (blnRgst = True) Then
        For i = 1 To colBpcaCtrlGrp.Count
            clsBpcaCtrlCh(i).Clear
        Next i
    End If
    Erase clsBpcaCtrlCh
    Set colBpcaCtrlGrp = Nothing
    Set MyForm = Nothing
    blnRgst = False
    intPreIndex = 0
End Sub

'---( Count property )---------------------------------------------
Public Property Get Count() As Integer
    Count = colBpcaCtrlGrp.Count
End Property

'---( getIndex property )---------------------------------------------
'It returns a value of "Index" becoming necessary for each property from a control name.
'In the case of a non-registration name, it returns -1.
Public Property Get getIndex(ByVal CtrlName As String) As Integer
Dim i As Integer
    getIndex = -1
    If (blnRgst = True) Then
        For i = 1 To colBpcaCtrlGrp.Count
            If (colBpcaCtrlGrp(i).Name = CtrlName) Then
                getIndex = i
                Exit For
            End If
        Next i
    Else
    End If
End Property

'---( Item property : Default property)----------------------------
'I return individual control objects from the control array.

Public Property Get Item(ByVal Index As Integer) As Object
Attribute Item.VB_UserMemId = 0
' Attribute Item.VB_UserMemId = 0

'(Note)
'The Item property becomes the Default property.
'The statement("Attribute Item.VB_UserMemId = 0") mentioned above is added
'to this part of the class module to assume it the Default property
'(you do not watch it from a code window).
'If you watch the export file of this class module, you can confirm it.

    If (blnRgst = True) And _
       (Index > 0) And (Index <= colBpcaCtrlGrp.Count) Then
        Set Item = colBpcaCtrlGrp(Index)
    Else
        Set Item = Nothing
    End If
End Property

'---( InitBColor property )------------------------------------------
'It returns a stored initial background color
Public Property Get InitBColor(ByVal Index As Integer) As Long
    If (blnRgst = True) And _
       (Index > 0) And (Index <= colBpcaCtrlGrp.Count) Then
        InitBColor = clsBpcaCtrlCh(Index).InitBColor
    Else
        InitBColor = -1
    End If
End Property

'===================================================================
' FocusCheck method to be called from clsBpcaFocusCh & UserForm
'===================================================================
Public Sub FocusCheck()
Dim objNowActCtrl As Object
Dim intNowIndex As Integer
Dim i As Integer
    If (blnRgst = False) Then
        Exit Sub
    End If

    'Get ActiveControl
    Set objNowActCtrl = GetActCtrl(MyForm)

    If (objNowActCtrl Is Nothing) Then
        If (intPreIndex = 0) Then
            '[Nothing to Nothing]  There is no change in anything.
        Else
            'LostFocus only (Focus movement to the outside of the registration control group)
            RaiseEvent LostFocus(intPreIndex)
            intPreIndex = 0
        End If
    Else
        'The acquisition of the registration number in the class of ActiveControl.
        intNowIndex = 0
        For i = 1 To colBpcaCtrlGrp.Count
            If (objNowActCtrl Is colBpcaCtrlGrp(i)) Then
                intNowIndex = i
                Exit For
            End If
        Next i

        If (intNowIndex = 0) Then
            If (intPreIndex = 0) Then
                '[Nothing to Nothing]  There is no change in anything.
            Else
                'LostFocus only (Focus movement to the outside of the registration control group)
                RaiseEvent LostFocus(intPreIndex)
                intPreIndex = 0
            End If
        Else
            If (intPreIndex = 0) Then
                'GotFocus only (Focus movement to the inside of the registration control group)
                RaiseEvent GotFocus(intNowIndex)
                intPreIndex = intNowIndex
            Else
                If (intPreIndex = intNowIndex) Then
                    'There is no focus movement
                Else
                    'LostFocus  GotFocus
                    RaiseEvent LostFocus(intPreIndex)
                    RaiseEvent GotFocus(intNowIndex)
                    intPreIndex = intNowIndex
                End If
            End If
        End If
    End If
End Sub

'==============================================================
' Recursive call function [ GetActCtrl ]
'==============================================================
'It hand UserForm object which is a top container to ContainerCtrl.
'When ActiveControl is a container,
'it acquire ActiveControl of the bottom layer by repeating a Recursive-Call.
Private Function GetActCtrl(ByVal ContainerCtrl As Object) As Object
Dim objActCtrl As Object
    Set objActCtrl = ContainerCtrl.ActiveControl
    If (objActCtrl Is Nothing) Then
        Set GetActCtrl = Nothing
    Else
        Select Case TypeName(objActCtrl)
          Case "Frame"
            'In the case of Frame, Recursive-Call by the Frame
            Set objActCtrl = GetActCtrl(objActCtrl)
          Case "MultiPage"
            'In the case of MultiPage, Recursive-Call by the Selected-Page
            Set objActCtrl = GetActCtrl(objActCtrl.SelectedItem)
          Case "TabStrip"
            'In the case of TabStrip, [Nothing]
            Set objActCtrl = Nothing
          Case Else
            'Normal Control
        End Select
        Set GetActCtrl = objActCtrl
    End If
End Function

'=====[AddinBox(K.Tsunoda) CopyRight(C) 2004 Allrights Reserved.]========

